import Pygem.conf as conf
from sqlobject import *


class Member(SQLObject):
    _connection = conf.db
    _defaultOrder="Name"

    # Identity
    Name = StringCol()
    Firstname = StringCol()
    Nickname = StringCol()
    Birthdate = DateCol()
    Address = StringCol()
    PostalCode = StringCol()
    Town = StringCol()
    AddressComp = StringCol()
    Country = StringCol()
    Email = StringCol()
    Phone = StringCol()

    # Association
    Type = EnumCol(enumValues=["NotYet", "Active", "Old"], default="NotYet")
    RegDate = DateCol(default="1900-01-01")
    RenewDate = DateCol(default="1900-01-01")
    Contribution = CurrencyCol(default=0.0)
    PayMode = EnumCol(enumValues=["Check", "Cash", "Other"], default="Other")
    Mailbox = BoolCol(default=None)
    WebPage = BoolCol(default=None)

    #Misc
    Notes = StringCol(default="")


Member.createTable(ifNotExists=True)

