import gobject, gtk, gtk.glade
import Pygem.conf

import Pygem.backend as be

import datetime

class MemberList:
    def __init__(self, treeview):
        self.treeview = treeview
        
        column = gtk.TreeViewColumn("Nom", gtk.CellRendererText(), text=1)
        self.treeview.append_column(column)

        column = gtk.TreeViewColumn(u"Prnom", gtk.CellRendererText(), text=2)
        self.treeview.append_column(column)

        column = gtk.TreeViewColumn("Pseudo", gtk.CellRendererText(), text=3)
        self.treeview.append_column(column)

        column = gtk.TreeViewColumn("Cotisation", gtk.CellRendererText(), text=4)
        self.treeview.append_column(column)


        self.liststore = gtk.ListStore(gobject.TYPE_INT, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
        self.treeview.set_model(self.liststore)


        self.filter = None

    def set_filter(self, filter):
        self.filter = filter


    def populate(self):
        self.liststore.clear()
        
        # Load members
        if self.filter == None:
            members = be.Member.select()
        else:
            members = be.Member.selectBy(Type=self.filter)

        for member in members:
            iter = self.liststore.append()
            self.liststore.set_value(iter, 0, member.id)
            self.liststore.set_value(iter, 1, member.Name)
            self.liststore.set_value(iter, 2, member.Firstname)
            self.liststore.set_value(iter, 3, member.Nickname)

            now = datetime.date(1900, 01, 01).today()
            if member.RenewDate > member.RegDate:
                comp = member.RenewDate
            else:
                comp = member.RegDate

            diff = now - comp
            if diff.days > 365:
                contrib_text = u"Expire"
            elif diff.days > 330:
                contrib_text = u"Expire bientt"
            else:
                contrib_text = u" jour"
                
            self.liststore.set_value(iter, 4, contrib_text)

    def get_selected(self):
        return self.treeview.get_selection()

    def delete(self, sel):
        model, iter = sel.get_selected()
        if iter:
            id = model.get_value(iter, 0)
            name = model.get_value(iter, 1)
            firstname = model.get_value(iter, 2)
            
            confirm = gtk.MessageDialog(self.treeview.get_toplevel(),
                                        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                                        gtk.MESSAGE_QUESTION,
                                        gtk.BUTTONS_YES_NO,
                                        "Voulez-vous vraiment supprimer le membre %s %s ?" % (firstname, name)
                                        )

            ans = confirm.run()

            if ans == gtk.RESPONSE_YES:
                be.Member.delete(id)
                model.remove(iter)

            confirm.destroy()
            



